// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "IAssetLoader.hpp"

using namespace Dawn;

IAssetLoader::IAssetLoader(std::string fileName) {
  assertTrue(
    fileName.size() > 0,
    "IAssetLoader::IAssetLoader: fileName must be greater than 0"
  );
  this->fileName = fileName;
}

size_t IAssetLoader::setPosition(size_t position) {
  assertTrue(
    position >= 0,
    "IAssetLoader::setPosition: position must be greater than or equal to 0"
  );
  this->rewind();
  return this->skip(position);
}

IAssetLoader::~IAssetLoader() {
}