// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UILabel.hpp"

namespace Dawn {
  class UISimpleLabel : public UILabel {
    public:
      // @optional
      StateProperty<std::string> text;
      // @optional
      StateProperty<TrueTypeAsset*> font;
      // @optional
      StateProperty<uint32_t> size;
      // @optional
      StateProperty<flag_t> style;
      // @optional
      StateProperty<flag_t> decorations;
      // @optional
      StateProperty<struct Color> color;
      
      UISimpleLabel(SceneItem *item);

      void onStart() override;
  };
}